// ------------------------------------------------ssl begin----------------------------------------------------------

// Utility function to initialize OpenSSL
void initOpenSSL() {
    SSL_load_error_strings();   
    OpenSSL_add_ssl_algorithms();
}

// Utility function to create SSL context
SSL_CTX* createContext() {
    SSL_CTX* ctx = SSL_CTX_new(TLS_server_method());
    if (!ctx) {
        ERR_print_errors_fp(stderr);
        exit(EXIT_FAILURE);
    }
    return ctx;
}

// Utility function to configure context
    // Load the certificate and private key
void configureContext(SSL_CTX* ctx) {
    SSL_CTX_set_options(ctx, SSL_OP_NO_SSLv2);
    if (SSL_CTX_use_certificate_file(ctx, "cert.pem", SSL_FILETYPE_PEM) <= 0 ||
        SSL_CTX_use_PrivateKey_file(ctx, "key.pem", SSL_FILETYPE_PEM) <= 0) {
        ERR_print_errors_fp(stderr);
        exit(EXIT_FAILURE);
    }
}


//----------------------------------------------ssl end--------------------------------------------------------------------

// Функция для обработки каждого запроса
//void handleRequest(int client_socket) 
std::string handleRequest(const std::string& request)
{
    //char buffer[BUFFER_SIZE] = {0};
    //read(client_socket, buffer, BUFFER_SIZE);
    //std::string request(buffer);
    std::cout << "Received request:\n" << request << std::endl;

        // Проверка, чтобы определить, начинается ли запрос с "GET" для перенаправления HTTP на HTTPS
//     if (request.substr(0, 3) == "GET") {
//        // Поиск строки запроса
//         std::size_t pos = request.find("Host:");
//         if (pos != std::string::npos) {
//             std::string host = request.substr(pos + 6, request.find("\n", pos) - pos - 6);
//             std::string redirectResponse = "HTTP/1.1 301 Moved Permanently\n"
//                                             "Location: https://" + host + "\n"
//                                             "Connection: close\n\n";
//             return redirectResponse;
//         }
//     }
//     
    
    return parseRequest(request);
 
    //send(client_socket, response.c_str(), response.size(), 0);
    //close(client_socket);
}

// ------------------------------------------------ssl client begin----------------------------------------------------------
void handleClient(SSL* ssl) {
    char buffer[BUFFER_SIZE] = {0};
    
    // Accept SSL connection
    if (SSL_accept(ssl) <= 0) {
        ERR_print_errors_fp(stderr);
        return;
    }

    // Read from the SSL socket
    SSL_read(ssl, buffer, sizeof(buffer)); 
    std::string request(buffer);
    std::string response = handleRequest(request);

    // Write the response
    SSL_write(ssl, response.c_str(), response.size()); 

    SSL_shutdown(ssl); 
    SSL_free(ssl); 
}
// ------------------------------------------------ssl client end----------------------------------------------------------

// Основная функция веб-сервера
void webServer() 
{
    //--------------- ssl begin
   initOpenSSL(); // Initialize OpenSSL

    SSL_CTX* ctx = createContext(); // Create SSL context
    configureContext(ctx); // Configure the SSL context

    // --------------- ssl end
    
    int server_fd,new_socket;
    struct sockaddr_in address;
    int opt = 1;
    int addrlen = sizeof(address);

    if ((server_fd = socket(AF_INET, SOCK_STREAM, 0)) == 0) {
        perror("Socket failed");
        exit(EXIT_FAILURE);
    }

    if (setsockopt(server_fd, SOL_SOCKET, SO_REUSEADDR, &opt, sizeof(opt))) {
        perror("setsockopt");
        exit(EXIT_FAILURE);
    }

    address.sin_family = AF_INET;
    address.sin_addr.s_addr = INADDR_ANY;
    address.sin_port = htons(PORT);

    if (bind(server_fd, (struct sockaddr *)&address, sizeof(address)) < 0) {
        perror("Bind failed");
        exit(EXIT_FAILURE);
    }

    if (listen(server_fd, BACKLOG) < 0) {
        perror("Listen failed");
        exit(EXIT_FAILURE);
    }

    // Create a new SSL object
    //SSL* ssl;
    std::cout << "Server is listening on port " << PORT << std::endl;
   
    while (true) {
        new_socket = accept(server_fd, (struct sockaddr *)&address, (socklen_t*)&addrlen);
        if (new_socket < 0) {
            perror("Accept failed");
            //exit(EXIT_FAILURE);
            continue; // Продолжать выполнять, если ошибка
        }

 
         // Create a new SSL object for the connection
        SSL* ssl = SSL_new(ctx);
        SSL_set_fd(ssl, new_socket); // Bind the SSL object to the socket
/*
        Accept SSL connection
        if (SSL_accept(ssl) <= 0) {
            ERR_print_errors_fp(stderr);
            Создаём новый поток для обработки запроса
        std::thread(handleRequest, new_socket).detach(); // Используем detach, чтобы поток продолжал работать независимо
        
        } else {
            char buffer[BUFFER_SIZE] = {0};
            SSL_read(ssl, buffer, BUFFER_SIZE); // Read from the SSL socket
            std::string request(buffer);
            std::cout << "Received request:\n" << request << std::endl;
            
            std::string response = handleRequest(request.c_str());
            SSL_write(ssl, response.c_str(), response.size()); // Write the response
            SSL_set_fd(ssl, new_socket); // Bind the SSL object to the socket
            
*/
            // Create a new thread to handle the client
            std::thread(handleClient, ssl).detach(); // Используем detach, чтобы поток продолжал работать независимо

       
        
 //       SSL_shutdown(ssl); // Shutdown SSL connection
//        SSL_free(ssl); // Free the SSL object
//        close(new_socket); // Close the client socket
         }
    SSL_CTX_free(ctx); // Free SSL context
    EVP_cleanup(); // Cleanup OpenSSL
    
}
    
    
    
//-------------------------- http -> SSL ----------------------------------------
/*
void webServer() {
    // Инициализация OpenSSL
    initOpenSSL();
    SSL_CTX* ctx = createContext();
    configureContext(ctx);

    // Создание сокета для HTTP
    int httpServerFd = socket(AF_INET, SOCK_STREAM, 0);
    int opt = 1;
    setsockopt(httpServerFd, SOL_SOCKET, SO_REUSEADDR, &opt, sizeof(opt));

    struct sockaddr_in httpAddress;
    httpAddress.sin_family = AF_INET;
    httpAddress.sin_addr.s_addr = INADDR_ANY;
    httpAddress.sin_port = htons(80); // Порт для HTTP

    bind(httpServerFd, (struct sockaddr*)&httpAddress, sizeof(httpAddress));
    listen(httpServerFd, BACKLOG);

    // Создание сокета для HTTPS
    int httpsServerFd = socket(AF_INET, SOCK_STREAM, 0);
    struct sockaddr_in httpsAddress;
    httpsAddress.sin_family = AF_INET;
    httpsAddress.sin_addr.s_addr = INADDR_ANY;
    httpsAddress.sin_port = htons(443); // Порт для HTTPS

    bind(httpsServerFd, (struct sockaddr*)&httpsAddress, sizeof(httpsAddress));
    listen(httpsServerFd, BACKLOG);

    std::cout << "HTTP Server is listening on port 80" << std::endl;
    std::cout << "HTTPS Server is listening on port 443" << std::endl;

    while (true) {
        fd_set readfds;
        FD_ZERO(&readfds);
        FD_SET(httpServerFd, &readfds);
        FD_SET(httpsServerFd, &readfds);
        int maxFd = std::max(httpServerFd, httpsServerFd);
        
        if (select(maxFd + 1, &readfds, nullptr, nullptr, nullptr) < 0) {
            perror("select failed");
            continue; // handle select failure
        }

        // Обработка HTTP-запроса
        if (FD_ISSET(httpServerFd, &readfds)) {
            int newSocket = accept(httpServerFd, nullptr, nullptr);
            char buffer[BUFFER_SIZE] = {0};
            read(newSocket, buffer, sizeof(buffer));
            std::string request(buffer);
            std::string response = handleRequest(request);
            send(newSocket, response.c_str(), response.size(), 0);
            close(newSocket);
        }

        // Обработка HTTPS-запроса
        if (FD_ISSET(httpsServerFd, &readfds)) {
            int newSocket = accept(httpsServerFd, nullptr, nullptr);
            SSL* ssl = SSL_new(ctx);
            SSL_set_fd(ssl, newSocket);
            handleClient(ssl); // Обработчик для обработки клиентских запросов SSL
        }
    }

    SSL_CTX_free(ctx);
    EVP_cleanup();
}
*/
 

